#include "main.h"

void Transform_World(double **Transformation_Matrix, world *World)
{
   int      i;
   int      Num_Polygons = World -> Num_Polygons;
   int      Num_Vertices = World -> Max_Vertices_per_Polygon;

   polygon *Polygons = World -> Polygons;
   int      mask;
   vertex  *Vertices = World -> Vertices;

   double   x;
   double   y;
   double   z;
   double   h;

   double   Transformation_Matrix_Col_0[4];
   double   Transformation_Matrix_Col_1[4];
   double   Transformation_Matrix_Col_2[4];
   double   Transformation_Matrix_Col_3[4];

   Num_Vertices *= Num_Polygons;

   for (i = 0; i < 4; i++)
   {
      Transformation_Matrix_Col_0[i] = Transformation_Matrix[i][0];
      Transformation_Matrix_Col_1[i] = Transformation_Matrix[i][1];
      Transformation_Matrix_Col_2[i] = Transformation_Matrix[i][2];
      Transformation_Matrix_Col_3[i] = Transformation_Matrix[i][3];
#if 0
      printf("Transformation_Matrix_Col_0[%d] = %g\n",
             i, Transformation_Matrix_Col_0[i]);
      printf("Transformation_Matrix_Col_1[%d] = %g\n",
             i, Transformation_Matrix_Col_1[i]);
      printf("Transformation_Matrix_Col_2[%d] = %g\n",
             i, Transformation_Matrix_Col_2[i]);
      printf("Transformation_Matrix_Col_3[%d] = %g\n",
             i, Transformation_Matrix_Col_3[i]);
#endif
   }

   for (i = 0; i < Num_Vertices; i++)
   {
      x = Vertices[i].x;
      y = Vertices[i].y;
      z = Vertices[i].z;
      h = x * Transformation_Matrix_Col_3[0]
          + y * Transformation_Matrix_Col_3[1]
          + z * Transformation_Matrix_Col_3[2]
          + Transformation_Matrix_Col_3[3];

      Vertices[i].sx = (x * Transformation_Matrix_Col_0[0]
                        + y * Transformation_Matrix_Col_0[1]
                        + z * Transformation_Matrix_Col_0[2]
                        + Transformation_Matrix_Col_0[3]) / h;

      Vertices[i].sy = (x * Transformation_Matrix_Col_1[0]
                        + y * Transformation_Matrix_Col_1[1]
                        + z * Transformation_Matrix_Col_1[2]
                        + Transformation_Matrix_Col_1[3]) / h;

      Vertices[i].sz = (x * Transformation_Matrix_Col_2[0]
                        + y * Transformation_Matrix_Col_2[1]
                        + z * Transformation_Matrix_Col_2[2]
                        + Transformation_Matrix_Col_2[3]) / h;
#if 0
      printf("(x, y, z) = (%g, %g, %g); (sx, sy, sz) = (%g, %g, %g)\n",
             x, y, z, Vertices[i].sx, Vertices[i].sy, Vertices[i].sz);
#endif
   }

   mask = VERTEX_MASK(sx) | VERTEX_MASK(sy) | VERTEX_MASK(sz)
          | VERTEX_MASK(r) | VERTEX_MASK(g) | VERTEX_MASK(b);

   for (i = 0; i < Num_Polygons; i++)
   {
      Polygons[i].mask = mask;
   }
}
